/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import cdac.medinfo.sdk.dcm30_04.templates.dicomsnomedmap.EnumChestCardiacSNOMEDMap;
import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_AorticRootDescription;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_AorticRootDescription;


/**
 * This class represents AorticRootDescription - CID3709
 */
public class AorticRootDescription_CID3709 
{
	
	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;

	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;
	/**
	 * The SNOMED CT ID for template.
	 */
	private String strSNOMEDCTID = null;
	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;

	/**
	 * Instantiates a new AorticRootDescription_CID3709 Template 
	 */
	public AorticRootDescription_CID3709()
	{

	}

	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}
	/**
	 * Retrieves the value for SNOMED-CT ID.
	 * @return String value for SNOMED-CT ID.
	 */
	public String getSNOMEDCTID() 
	{
		return strSNOMEDCTID;
	}
	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumAorticRootDescription Object of EnumCM_AorticRootDescription represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_AorticRootDescription enumAorticRootDescription)
	{
		switch(enumAorticRootDescription)
		{
		case ANEURYSM_OF_AORTIC_ROOT:
			this.strCodeValue = EnumCV_AorticRootDescription.ANEURYSM_OF_AORTIC_ROOT_R_002CD.getValue();
			break;
		case ANNULAR_ABSCESS_OF_AORTIC_ROOT:
			this.strCodeValue = EnumCV_AorticRootDescription.ANNULAR_ABSCESS_OF_AORTIC_ROOT_R_002D1.getValue();
			break;
		case ENLARGED_AORTIC_ROOT:
			this.strCodeValue = EnumCV_AorticRootDescription.ENLARGED_AORTIC_ROOT_R_00301.getValue();
			break;
		case NORMAL_AORTIC_ROOT:
			this.strCodeValue = EnumCV_AorticRootDescription.NORMAL_AORTIC_ROOT_R_0033C.getValue();
			break;
		case POST_STENOTIC_DILATION:
			this.strCodeValue = EnumCV_AorticRootDescription.POST_STENOTIC_DILATION_R_003A1.getValue();
			break;
		case RUPTURED_SINUS_OF_VALSALVA:
			this.strCodeValue = EnumCV_AorticRootDescription.RUPTURED_SINUS_OF_VALSALVA_D3_83660.getValue();
			break;
		}
	}
	/**
	 * Sets the SNOMED-CT ID.
	 * @param enumAorticRootDescription Object of EnumCM_AorticRootDescription represents Code Meaning.
	 */
	private void setSNOMEDCTID(EnumCM_AorticRootDescription enumAorticRootDescription)
	{
		switch(enumAorticRootDescription)
		{
		case NORMAL_AORTIC_ROOT : this.strSNOMEDCTID =EnumChestCardiacSNOMEDMap.NORMAL_AORTIC_ROOT.getSNOMEDCTID(); break;
		case ENLARGED_AORTIC_ROOT : this.strSNOMEDCTID =EnumChestCardiacSNOMEDMap.ENLARGED_AORTIC_ROOT.getSNOMEDCTID(); break;
		case ANEURYSM_OF_AORTIC_ROOT : this.strSNOMEDCTID =EnumChestCardiacSNOMEDMap.ANEURYSM_OF_AORTIC_ROOT.getSNOMEDCTID(); break;
		case ANNULAR_ABSCESS_OF_AORTIC_ROOT : this.strSNOMEDCTID =EnumChestCardiacSNOMEDMap.ANNULAR_ABSCESS_OF_AORTIC_ROOT.getSNOMEDCTID(); break;
		case POST_STENOTIC_DILATION : this.strSNOMEDCTID =EnumChestCardiacSNOMEDMap.POST_STENOTIC_DILATION.getSNOMEDCTID(); break;
		case RUPTURED_SINUS_OF_VALSALVA : this.strSNOMEDCTID =EnumChestCardiacSNOMEDMap.RUPTURED_SINUS_OF_VALSALVA.getSNOMEDCTID(); break;
		}
	}
	/**
	 * Sets the value for AorticRootDescription
	 * @param enumAorticRootDescription Object of EnumCM_AorticRootDescription.
	 */
	public void setAorticRootDescription(EnumCM_AorticRootDescription enumAorticRootDescription)
	{
		/**
		 * Retrieves the value for CodingSchemeDesignator, CodingSchemeVersion and Code Meaning and 
		 * sets the Code Value according to Code Meaning.
		 */
		this.strCodeMeaning = enumAorticRootDescription.getValue();
		this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.LN.getValue();
		
		/**
		 * set code Value
		 */
		setCodeValue(enumAorticRootDescription);
		/**
		 * set SNOMED-CT ID
		 */
		setSNOMEDCTID(enumAorticRootDescription);
	}
}
